import poser, wx

class dlgRender ( wx.Dialog ):
	
	def __init__( self, parent ):
		wx.Dialog.__init__ ( self, parent, id = wx.ID_ANY, title = u"Snarly's render settings", pos = wx.DefaultPosition, size = wx.Size( 233,222 ), style = wx.DEFAULT_DIALOG_STYLE )
		
		self.SetSizeHintsSz( wx.DefaultSize, wx.DefaultSize )
		
		bSizer1 = wx.BoxSizer( wx.VERTICAL )
		
		self.ctl_IDL = wx.CheckBox( self, wx.ID_ANY, u"Enable IDL", wx.DefaultPosition, wx.DefaultSize, 0 )
		bSizer1.Add( self.ctl_IDL, 0, wx.ALL, 5 )
		
		bSizer5 = wx.BoxSizer( wx.HORIZONTAL )
		
		self.ctl_RTBounces = wx.SpinCtrl( self, wx.ID_ANY, wx.EmptyString, wx.DefaultPosition, wx.Size( 60,-1 ), wx.SP_ARROW_KEYS, 0, 10, 1 )
		bSizer5.Add( self.ctl_RTBounces, 0, wx.ALL, 5 )
		
		self.m_staticText4 = wx.StaticText( self, wx.ID_ANY, u"Ray Trace bounces", wx.DefaultPosition, wx.DefaultSize, 0 )
		self.m_staticText4.Wrap( -1 )
		bSizer5.Add( self.m_staticText4, 0, wx.ALIGN_CENTER_VERTICAL|wx.ALL, 5 )
		
		bSizer1.Add( bSizer5, 0, wx.EXPAND, 5 )
		
		bSizer2 = wx.BoxSizer( wx.HORIZONTAL )
		
		self.ctl_Bounces = wx.SpinCtrl( self, wx.ID_ANY, wx.EmptyString, wx.DefaultPosition, wx.Size( 60,-1 ), wx.SP_ARROW_KEYS, 0, 12, 7 )
		bSizer2.Add( self.ctl_Bounces, 0, wx.ALL, 5 )
		
		self.m_staticText1 = wx.StaticText( self, wx.ID_ANY, u"Bounces", wx.DefaultPosition, wx.DefaultSize, 0 )
		self.m_staticText1.Wrap( -1 )
		bSizer2.Add( self.m_staticText1, 0, wx.ALIGN_CENTER_VERTICAL|wx.ALL, 5 )
		
		bSizer1.Add( bSizer2, 0, wx.EXPAND, 5 )
		
		bSizer3 = wx.BoxSizer( wx.HORIZONTAL )
		
		self.ctl_Samples = wx.SpinCtrl( self, wx.ID_ANY, wx.EmptyString, wx.DefaultPosition, wx.Size( 60,-1 ), wx.SP_ARROW_KEYS, 0, 2024, 200 )
		bSizer3.Add( self.ctl_Samples, 0, wx.ALL, 5 )
		
		self.txt_Samples = wx.StaticText( self, wx.ID_ANY, u"Samples", wx.DefaultPosition, wx.DefaultSize, 0 )
		self.txt_Samples.Wrap( -1 )
		bSizer3.Add( self.txt_Samples, 0, wx.ALIGN_CENTER_VERTICAL|wx.ALL, 5 )
		
		bSizer1.Add( bSizer3, 0, wx.EXPAND, 5 )
		
		bSizer4 = wx.BoxSizer( wx.HORIZONTAL )
		
		self.ctl_IC = wx.SpinCtrl( self, wx.ID_ANY, wx.EmptyString, wx.DefaultPosition, wx.Size( 60,-1 ), wx.SP_ARROW_KEYS, 0, 100, 20 )
		bSizer4.Add( self.ctl_IC, 0, wx.ALL, 5 )
		
		self.m_staticText3 = wx.StaticText( self, wx.ID_ANY, u"Irradience Cache", wx.DefaultPosition, wx.DefaultSize, 0 )
		self.m_staticText3.Wrap( -1 )
		bSizer4.Add( self.m_staticText3, 0, wx.ALIGN_CENTER_VERTICAL|wx.ALL, 5 )
		
		bSizer1.Add( bSizer4, 0, wx.EXPAND, 5 )
		
		self.ctl_Apply = wx.Button( self, wx.ID_ANY, u"Apply", wx.DefaultPosition, wx.DefaultSize, 0 )
		bSizer1.Add( self.ctl_Apply, 0, wx.ALL, 5 )
		
		self.SetSizer( bSizer1 )
		self.Layout()
		
		self.Centre( wx.BOTH )
		
		# Connect Events
		self.ctl_Apply.Bind( wx.EVT_BUTTON, self.Apply )
	
	def __del__( self ):
		pass
	
	# Virtual event handlers, overide them in your derived class
	def Apply( self, event ):
		event.Skip()
		
class RenderSettings(dlgRender):
	def __init__(self):
		dlgRender.__init__(self, None)
		
		self.firefly = poser.Scene().CurrentFireFlyOptions()
		
		self.ctl_IDL.SetValue(self.firefly.UseGI())
		self.ctl_RTBounces.SetValue(self.firefly.MaxRayDepth())
		self.ctl_Bounces.SetValue(self.firefly.GINumBounces())
		self.ctl_Samples.SetValue(self.firefly.GINumSamples())
		self.ctl_IC.SetValue(100 - int(self.firefly.GIMaxError() * 100))
	
	def Apply( self, event ):
		
		self.firefly.SetManual(1)
		
		if self.ctl_IDL.IsChecked():
			self.firefly.SetUseGI(1)
			self.firefly.SetRayTracing(1)
			self.firefly.SetMaxRayDepth(self.ctl_RTBounces.GetValue())
			self.firefly.SetGIIntensity(1.0)
		else:
			self.firefly.SetUseGI(0)
			self.firefly.SetGIIntensity(0.0)
			
		self.firefly.SetGINumBounces(self.ctl_Bounces.GetValue())
		self.firefly.SetGINumSamples(self.ctl_Samples.GetValue())
		self.firefly.SetGIMaxError(1 - self.ctl_IC.GetValue() / 100.0)
		
		self.EndModal(0)
		
def Main():
	dlg = RenderSettings()
	dlg.CenterOnScreen()
	dlg.ShowModal()
	dlg.Destroy()	
		
Main()
del Main
del RenderSettings